/**
+ Simple calculator

Now we'll write very simple Bolek-like calculator. Bolek calculator
read a number, an operator (+, - etc), and second number.  Then it
performs operation and prints result.
*/

section init
{
	// prompt user {0}
	puts("bolek> ");

	// read data {1}
	int x = read_int();
	// {2}
	string op = read_string();
	int y = read_int();

	// declare variable for result {3}
	int res;

	// depending on operator perform operation
	// {4}
	switch op {
	case "+": 	res = x + y;
	case "-": 	res = x - y;
	case ":": // {5}
	case "/": 	res = x / y;
	case "*": 	res = x * y;
	// note this funny syntax for default: {6}
	case _:
		puts("Invalid operator: " + op);
		res = 0;	// {7}
	}

	// {8}
	puts("result: " + itoa(res) + "\n");
}

/**
Notes about the example.

{0} Both C (/ *  * /) and C++ (// ...) style comments are available.
You may use whichever you want.  C-style comments do nest, unlike in
C, however content of comment is not lexed, so using this feature for
disabling code can fail if you have comment delimeters in string literals.

{1} Variables can be declared and initialized in middle of the block,
just like in C99 or C++.  [read_int()] function skips any whitespace
in input, reads one word and translates it to integer.  Word is seqence 
of non-whitespace characters. (so our example will work for "2 + 2", but
not for "2+2").

{2} Strings are built in datatype, just like integers or floats.
Few basic operators, like [==], [<], [>=] etc, [+], [+=] support 
strings.  Their sementics is just what you expect :-)

{3} Variables can de declared without initialization, just like in C.
However compiler ensures, that each variable is initialized before
it is used (just like in Java).  Therefore we need to initialize [res]
even if nothing sensible can be written to it in {7}, as we are going
to print it anyway in {8}.  

Checking of initialization is quite conservative, even more conservative
then the one javac performs, so be forgiving for compiler when it
complains about ,,possibly uninitialized variables'' as it is just a
stupid program ;)

{4} C switch statment is just a poor relative to its Gont cousin.
It's by no way limited to integers, here we use it to match string values,
but we'll later learn how to match complex data types.

One more important note about switch statment in Gont: there are no
[break] statements in it.  Fall-through occurs only if there are no
statements after case clause.  In our example, at {5} controls falls
through ":" to "/", but does not fall through from "/" to "*".

There is no need for [break] after [res = ...] assignments.
In fact in Gont [break] has nothing to do with [switch].

And one more remark -- [switch (op) {] would be as good as [switch op {].
This is just a matter of style and more typing :)

{6} There is no "default:" label in Gont, instead one need to use
"case _:".  Take it as an strange deviation for now.  You should
always supply "case _:" as last clause in switch.  If no case matches
[Match_failure] exception is raised, and if you fail to catch it
your program terminates.

{8} Here we use string concatenation with [+] operator.  [itoa(i)] returns
string representation of [i].
*/
