/**
+ Bolek is getting better

We'll now improve our Bolek calculator from previous example
to read more then one expression.
*/

// {0}
void process_line()
{
	puts("bolek ][ > \n");

	int x, y, res;
	string op;
	
	// {1}	
	(x, op, y) = (read_int(), read_string(), read_int());

	switch op {
	case "+": 	res = x + y;
	case "-": 	res = x - y;
	case ":":
	case "/": 	res = x / y;
	case "*": 	res = x * y;
	case _:
		puts("Invalid operator: " + op);
		// {2}
		return;
	}
	
	puts("result: " + itoa(res) + "\n");
}

section init
{
	for (;;)			// {3}
		process_line(); 	// {4}
}

/**
{0} Functions are defined much like in C.  One gotcha, is [void f(void)].
In C it defines [f] to get no parameters and return no value.  In Gont
if defines [f] to get one unnamed value of type [void] and
return value of type [void].  In C [void] type is... ergh... void. There
are no values of this type.  OTOH in Gont there is one value of type 
[void], it is spelled [()].  Therefore after definition [void f(void) {}]
function [f] needs to be called as [f(())] which is probably not what you
want.

{1} Here we have multiple assignment.  First each expression on right
hand side is evaluated, in left-to-right order.  Then, after all 
expressions are evaluated, they are assigned to respective variables
on the left hand side.  Composition of expressions on right-hand-side
is useful in more general context then just multiple assigment.
It is called tuple expression.  We'll learn more about them soon.

Note that order of evaluation of read_*() functions is crucial for us.
We are lucky, that Gont gurantees tuple arguments to be evaluated
left-to-right.  Function parameters are also evaluated in left-to-right
order.  OTOH in C order of evaluation of function arguments is
undefined.

{2} [return] leaves current function, just like in C.  Important point
is that, as we are going to leave the function and never use [res],
we don't initialize it.  Gont compiler won't complain about that.

{3} [for(;;)] (and [while (true)] for that matter) is endless loop. It can
be stopped by [break] statement, but we never do that, this version
of Bolek, once run, needs to be killed with some external means ;-)

{4} Function call looks just like in C.
*/
