/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 900 $ $LastChangedDate: 2002-09-08 01:04:18 +0200 (Sun, 08 Sep 2002) $
 *
 * Standard library for Gont, Unitype module interface.
 */

union general_category {
	void Letter_uppercase;		// Lu
	void Letter_lowercase;		// Ll
	void Letter_titlecase;		// Lt
	void Letter_modifier;		// Lm
	void Letter_other;		// Lo
	void Mark_non_spacing;		// Mn
	void Mark_space_combining;	// Mc
	void Mark_enclosing;		// Me
	void Number_decimal_digit;	// Nd
	void Number_letter;		// Nl
	void Number_other;		// No
	void Punctation_connector;	// Pc
	void Punctation_dash;		// Pd
	void Punctation_open;		// Ps
	void Punctation_close;		// Pe
	void Punctation_initial;	// Pi
	void Punctation_final;		// Pf
	void Punctation_other;		// Po
	void Symbol_math;		// Sm
	void Symbol_currency;		// Sc
	void Symbol_modifier;		// Sk
	void Symbol_other;		// So
	void Separator_space;		// Zs
	void Separator_line;		// Zl
	void Separator_paragraph;	// Zp
	void Other_control;		// Cc
	void Other_format;		// Cf
	void Other_surrogate;		// Cs
	void Other_private_use;		// Co
	void Other_not_assigned;	// Cn
	void Unknown;			// not in UnicodeData.txt
}

general_category get_category(char c) = "Unitype__get_category";

// Letter_uppercase
bool is_uppercase(char c) = "Unitype__is_uppercase";

// Letter_lowercase
bool is_lowercase(char c) = "Unitype__is_lowercase";

// Letter_*
bool is_letter(char c) = "Unitype__is_letter";

// Number_*
bool is_number(char c) = "Unitype__is_number";

// Number_* or Letter_*
bool is_alnum(char c) = "Unitype__is_alnum";

// Punctation_*
bool is_punct(char c) = "Unitype__is_punct";

// Other_control
bool is_control(char c) = "Unitype__is_control";

// Symbol_*
bool is_symbol(char c) = "Unitype__is_symbol";

// Mark_*
bool is_mark(char c) = "Unitype__is_mark";

// Separator_*
bool is_separator(char c) = "Unitype__is_separator";

bool is_ascii(char c);
bool is_7_bit(char c);
bool is_8_bit(char c);
bool is_16_bit(char c);

bool is_ascii_uppercase(char c);
bool is_ascii_lowercase(char c);
bool is_ascii_letter(char c);
bool is_ascii_alnum(char c);
bool is_ascii_number(char c);
bool is_ascii_xnumber(char c);
// ' ' or '\t'
bool is_ascii_blank(char c);

char to_uppercase(char c) = "Unitype__to_uppercase";
char to_lowercase(char c) = "Unitype__to_lowercase";
int get_digit_value(char c) = "Unitype__get_digit_value";
