/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 824 $ $LastChangedDate: 2002-09-01 11:21:45 +0200 (Sun, 01 Sep 2002) $
 *
 * Addons library for Gont, Xml module interface.
 */

type doc;

union node {
	*(string, <node>list, <*(string, string)>list) Element;
	string Text;
}

doc parse_file(string filename, bool skip_spaces);
doc parse_string(string xml, bool skip_spaces);
node root_node(doc);

doc make_doc(node root);
string string_of_doc(doc);
string string_of_doc_indented(doc);

node make_text_node(string s);
node make_element_node(string name, <node>list children,
			<*(string, string)>list);
void save_to_stream(doc, Stdio::FILE f);
void save_to_stream_indented(doc, Stdio::FILE f);
void save_to_file(doc, string name);
void save_to_file_indented(doc, string name);

// Node manipulation functions.
// can raise Not_found
node find_element(string name, node n);
// ditto
string prop_value(string name, node n);
// can raise Invalid_argument
string prop_value_default(string name, node n, string dfl);

exception string Parse_error;
